diff --git a/src/backend/distributed/connection/placement_connection.c b/src/backend/distributed/connection/placement_connection.c
index b9e2e4672c1..d130ab171c3 100644
--- a/src/backend/distributed/connection/placement_connection.c
+++ b/src/backend/distributed/connection/placement_connection.c
@@ -627,6 +627,15 @@ FindPlacementListConnection(int flags, List *placementAccessList, const char *us
 				foundModifyingConnection = true;
 			}
 		}
+		else if (placementConnection->hadDDL || placementConnection->hadDML)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_ACTIVE_SQL_TRANSACTION),
+					 errmsg("cannot perform query because modifications were "
+							"made over a connection that cannot be used at "
+							"this time, probably because a different user was"
+							"used before")));
+		}
 	}
 
 	return chosenConnection;
diff --git a/src/test/regress/expected/set_role_in_transaction.out b/src/test/regress/expected/set_role_in_transaction.out
new file mode 100644
index 00000000000..ce5c4fdb7a4
--- /dev/null
+++ b/src/test/regress/expected/set_role_in_transaction.out
@@ -0,0 +1,121 @@
+-- Regression test for this issue:
+-- https://github.com/citusdata/citus/issues/3867
+SET citus.shard_count = 4;
+SET citus.next_shard_id TO 1954000;
+CREATE SCHEMA set_role_in_transaction;
+SET search_path TO set_role_in_transaction;
+CREATE TABLE t(a int);
+SELECT create_distributed_table('t', 'a');
+ create_distributed_table
+---------------------------------------------------------------------
+
+(1 row)
+
+CREATE USER user1 SUPERUSER;
+NOTICE:  not propagating CREATE ROLE/USER commands to worker nodes
+HINT:  Connect to worker nodes directly to manually create all necessary users and roles.
+CREATE USER user2 SUPERUSER;
+NOTICE:  not propagating CREATE ROLE/USER commands to worker nodes
+HINT:  Connect to worker nodes directly to manually create all necessary users and roles.
+-- Not needed on Citus Enterprise
+SELECT run_command_on_workers('CREATE USER user1');
+      run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,"CREATE ROLE")
+ (localhost,57638,t,"CREATE ROLE")
+(2 rows)
+
+SELECT run_command_on_workers('CREATE USER user2');
+      run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,"CREATE ROLE")
+ (localhost,57638,t,"CREATE ROLE")
+(2 rows)
+
+GRANT ALL ON SCHEMA set_role_in_transaction TO user1;
+GRANT ALL ON SCHEMA set_role_in_transaction TO user2;
+GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user1;
+GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user2;
+-- Not needed on Citus Enterprise
+SELECT run_command_on_workers('GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user1');
+  run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,GRANT)
+ (localhost,57638,t,GRANT)
+(2 rows)
+
+SELECT run_command_on_workers('GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user2');
+  run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,GRANT)
+ (localhost,57638,t,GRANT)
+(2 rows)
+
+-- Visibility bugs
+SET ROLE user1;
+SET search_path TO set_role_in_transaction;
+BEGIN;
+INSERT INTO t values (1);
+SELECT * FROM t; -- 1 is visible as expected
+ a
+---------------------------------------------------------------------
+ 1
+(1 row)
+
+SET ROLE user2;
+SET search_path TO set_role_in_transaction;
+SELECT * FROM t; -- 1 is not visible
+ERROR:  cannot perform query because modifications were made over a connection that cannot be used at this time
+INSERT INTO t values (1); -- assert failure
+ERROR:  current transaction is aborted, commands ignored until end of transaction block
+SELECT * from t;
+ERROR:  current transaction is aborted, commands ignored until end of transaction block
+ROLLBACK;
+-- Self deadlock
+SET ROLE user1;
+SET search_path TO set_role_in_transaction;
+BEGIN;
+TRUNCATE t;
+SET ROLE user2;
+SET search_path TO set_role_in_transaction;
+-- assert failure or self deadlock (it is detected by deadlock detector)
+INSERT INTO t values (2);
+ERROR:  cannot perform query because modifications were made over a connection that cannot be used at this time
+ROLLBACK;
+RESET ROLE;
+REVOKE ALL ON SCHEMA set_role_in_transaction FROM user1;
+REVOKE ALL ON SCHEMA set_role_in_transaction FROM user2;
+REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user1;
+REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user2;
+SELECT run_command_on_workers('REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user1');
+   run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,REVOKE)
+ (localhost,57638,t,REVOKE)
+(2 rows)
+
+SELECT run_command_on_workers('REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user2');
+   run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,REVOKE)
+ (localhost,57638,t,REVOKE)
+(2 rows)
+
+DROP USER user1;
+DROP USER user2;
+SELECT run_command_on_workers('DROP USER user1');
+     run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,"DROP ROLE")
+ (localhost,57638,t,"DROP ROLE")
+(2 rows)
+
+SELECT run_command_on_workers('DROP USER user2');
+     run_command_on_workers
+---------------------------------------------------------------------
+ (localhost,57637,t,"DROP ROLE")
+ (localhost,57638,t,"DROP ROLE")
+(2 rows)
+
+DROP SCHEMA set_role_in_transaction CASCADE;
+NOTICE:  drop cascades to table t
diff --git a/src/test/regress/multi_schedule b/src/test/regress/multi_schedule
index 0b327b3947c..860afb65da9 100644
--- a/src/test/regress/multi_schedule
+++ b/src/test/regress/multi_schedule
@@ -91,7 +91,7 @@ test: multi_subquery_complex_reference_clause multi_subquery_window_functions mu
 test: sql_procedure multi_function_in_join row_types materialized_view
 test: multi_subquery_in_where_reference_clause full_join adaptive_executor propagate_set_commands
 test: multi_subquery_union multi_subquery_in_where_clause multi_subquery_misc
-test: multi_agg_distinct multi_agg_approximate_distinct multi_limit_clause_approximate multi_outer_join_reference multi_single_relation_subquery multi_prepare_plsql
+test: multi_agg_distinct multi_agg_approximate_distinct multi_limit_clause_approximate multi_outer_join_reference multi_single_relation_subquery multi_prepare_plsql set_role_in_transaction
 test: multi_reference_table multi_select_for_update relation_access_tracking
 test: custom_aggregate_support aggregate_support
 test: multi_average_expression multi_working_columns multi_having_pushdown having_subquery
diff --git a/src/test/regress/multi_schedule_hyperscale b/src/test/regress/multi_schedule_hyperscale
index fb102f868bc..3898fbbbc7f 100644
--- a/src/test/regress/multi_schedule_hyperscale
+++ b/src/test/regress/multi_schedule_hyperscale
@@ -65,7 +65,7 @@ test: multi_subquery_complex_reference_clause multi_subquery_window_functions mu
 test: multi_function_in_join row_types
 test: multi_subquery_in_where_reference_clause full_join adaptive_executor propagate_set_commands
 test: multi_subquery_union multi_subquery_in_where_clause multi_subquery_misc
-test:  multi_limit_clause_approximate multi_single_relation_subquery
+test:  multi_limit_clause_approximate multi_single_relation_subquery set_role_in_transaction
 test: multi_select_for_update
 test: multi_average_expression multi_working_columns multi_having_pushdown
 test: multi_array_agg
diff --git a/src/test/regress/sql/set_role_in_transaction.sql b/src/test/regress/sql/set_role_in_transaction.sql
new file mode 100644
index 00000000000..50b75ed79eb
--- /dev/null
+++ b/src/test/regress/sql/set_role_in_transaction.sql
@@ -0,0 +1,61 @@
+-- Regression test for this issue:
+-- https://github.com/citusdata/citus/issues/3867
+SET citus.shard_count = 4;
+SET citus.next_shard_id TO 1959300;
+CREATE SCHEMA set_role_in_transaction;
+SET search_path TO set_role_in_transaction;
+CREATE TABLE t(a int);
+SELECT create_distributed_table('t', 'a');
+
+CREATE USER user1 SUPERUSER;
+CREATE USER user2 SUPERUSER;
+-- Not needed on Citus Enterprise
+SELECT run_command_on_workers('CREATE USER user1');
+SELECT run_command_on_workers('CREATE USER user2');
+GRANT ALL ON SCHEMA set_role_in_transaction TO user1;
+GRANT ALL ON SCHEMA set_role_in_transaction TO user2;
+GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user1;
+GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user2;
+-- Not needed on Citus Enterprise
+SELECT run_command_on_workers('GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user1');
+SELECT run_command_on_workers('GRANT ALL ON ALL TABLES IN SCHEMA set_role_in_transaction TO user2');
+
+-- Visibility bugs
+SET ROLE user1;
+SET search_path TO set_role_in_transaction;
+BEGIN;
+INSERT INTO t values (1);
+SELECT * FROM t; -- 1 is visible as expected
+SET ROLE user2;
+SET search_path TO set_role_in_transaction;
+SELECT * FROM t; -- 1 is not visible
+INSERT INTO t values (1); -- assert failure
+SELECT * from t;
+ROLLBACK;
+
+-- Self deadlock
+SET ROLE user1;
+SET search_path TO set_role_in_transaction;
+BEGIN;
+TRUNCATE t;
+SET ROLE user2;
+SET search_path TO set_role_in_transaction;
+-- assert failure or self deadlock (it is detected by deadlock detector)
+INSERT INTO t values (2);
+ROLLBACK;
+
+RESET ROLE;
+
+REVOKE ALL ON SCHEMA set_role_in_transaction FROM user1;
+REVOKE ALL ON SCHEMA set_role_in_transaction FROM user2;
+REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user1;
+REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user2;
+SELECT run_command_on_workers('REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user1');
+SELECT run_command_on_workers('REVOKE ALL ON ALL TABLES IN SCHEMA set_role_in_transaction FROM user2');
+
+DROP USER user1;
+DROP USER user2;
+SELECT run_command_on_workers('DROP USER user1');
+SELECT run_command_on_workers('DROP USER user2');
+
+DROP SCHEMA set_role_in_transaction CASCADE;
